=== debian/changelog ===
norm (1.5.8+dfsg2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:51:46 +0100

norm (1.5.8+dfsg2-2) unstable; urgency=medium

  * Add waf-python3.patch to convert the build system to python3,
    and change the build-dependency accordingly. (Closes: #937155)
  * Bump Standards-Version to 4.4.0, no changes.

 -- Luca Boccassi <bluca@debian.org>  Sat, 31 Aug 2019 17:20:41 +0100

norm (1.5.8+dfsg2-1) unstable; urgency=medium

  * Repack to remove additional Java pre-built binaries that sneaked
    into the latest version from the source.
  * Add support for "terse" DEB_BUILD_OPTIONS flag.
  * Add dependency libnorm-dev -> libpcap-dev and related pkg-config
    Libs.private flag on Hurd.
  * Bump Standards-Version to 4.2.1.

 -- Luca Boccassi <bluca@debian.org>  Mon, 17 Dec 2018 15:21:27 +0000
