=== debian/control ===
Source: norm
Section: libs
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Standards-Version: 4.4.0
Build-Depends: debhelper (>= 9), python3, libpcap-dev [hurd-i386],
Homepage: https://www.nrl.navy.mil/itd/ncs/products/norm

Package: libnorm1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.

Package: libnorm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libnorm-doc
Depends: ${misc:Depends}, libnorm1 (= ${binary:Version}),
         libpcap-dev [hurd-i386],
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.
 .
 This package provides the development files for norm.

Package: libnorm-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: dwww | dhelp | doc-central
Depends: ${misc:Depends},
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.
 .
 This package provides the documentation and examples for norm.
