## norm 1.5.9%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DNORM_CUSTOM_PROTOLIB_VERSION=./protolib \
		-DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=ON
