=== debian/changelog ===
norm (1.5.9+dfsg-4) unstable; urgency=medium

  * d/rules: add -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to fix FTBFS with
    CMake 4 (Closes: #1113330)
  * Switch to pkgconf
  * d/control: bump Standards-Version to 4.7.2, no changes
  * Fix norm.pc's Libs.private (Closes: #1076813)

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Oct 2025 15:46:55 +0100

norm (1.5.9+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063179

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:39:50 +0000

norm (1.5.9+dfsg-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * d/control: Generalize hurd-i386 into hurd-any.

  [ Patrice Duroux ]
  * Update d/watch (Closes: #1051151)

  [ Luca Boccassi ]
  * Bump Standards-Version to 4.6.2, no changes
  * Bump copyright year ranges in d/copyright
  * Bump debhelper-compat to 13
  * Add symlinks to guides html to fix Lintian errors

 -- Luca Boccassi <bluca@debian.org>  Mon, 01 Jan 2024 20:50:27 +0100

norm (1.5.9+dfsg-2) unstable; urgency=medium

  * Add build dependency on pkg-config

 -- Luca Boccassi <bluca@debian.org>  Mon, 15 Feb 2021 14:04:32 +0000

norm (1.5.9+dfsg-1) unstable; urgency=medium

  * Add Vcs fields, pointing to Salsa
  * Bump Standards-Version to 4.5.0, no changes
  * Update upstream source references to new Github repository
  * Switch to CMake and new Github layout
  * New upstream version 1.5.9
  * Build with CMake
  * Bump Standards-Version to 4.5.1, no changes
  * Set Rules-Requires-Root
  * Add new symbols from 1.5.9
  * Add debian/upstream metadata
  * Update short descriptions

 -- Luca Boccassi <bluca@debian.org>  Sun, 31 Jan 2021 16:58:39 +0000
