=== debian/control ===
--- 
+++ 
@@ -2,11 +2,17 @@
 Section: libs
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 9), python3, libpcap-dev [hurd-i386],
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev [hurd-any], libxml2-dev, pkgconf,
 Homepage: https://www.nrl.navy.mil/itd/ncs/products/norm
+Vcs-Browser: https://salsa.debian.org/debian/norm
+Vcs-Git: https://salsa.debian.org/debian/norm.git
 
-Package: libnorm1
+Package: libnorm1t64
+Provides: ${t64:Provides}
+Replaces: libnorm1
+Breaks: libnorm1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -22,9 +28,10 @@
 Architecture: any
 Multi-Arch: same
 Suggests: libnorm-doc
-Depends: ${misc:Depends}, libnorm1 (= ${binary:Version}),
-         libpcap-dev [hurd-i386],
-Description: NACK-Oriented Reliable Multicast (NORM) library
+Depends: ${misc:Depends}, libnorm1t64 (= ${binary:Version}),
+         libpcap-dev [hurd-any],
+         libxml2-dev,
+Description: NACK-Oriented Reliable Multicast (NORM) library (development files)
  The NORM protocol is designed to provide end-to-end reliable transport of
  bulk data objects or streams over generic IP multicast routing and forwarding
  services.
@@ -38,7 +45,7 @@
 Multi-Arch: foreign
 Recommends: dwww | dhelp | doc-central
 Depends: ${misc:Depends},
-Description: NACK-Oriented Reliable Multicast (NORM) library
+Description: NACK-Oriented Reliable Multicast (NORM) library (documentation)
  The NORM protocol is designed to provide end-to-end reliable transport of
  bulk data objects or streams over generic IP multicast routing and forwarding
  services.
