=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg,filenamemangle=s/(?:.*?)@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@-$1$2/ \
 https://github.com/USNavalResearchLaboratory/@PACKAGE@/tags (?:.*?/)@ANY_VERSION@@ARCHIVE_EXT@
